

_, Aleri = ...

Aleri.Functions = {}

function Aleri.Functions.ResetRoleTable()
Aleri.Database.Roles = {
	Tank = { DEATHKNIGHT = 0, WARRIOR = 0, DRUID = 0, PALADIN = 0 },
	Healer = { DRUID = 0, SHAMAN = 0, PRIEST = 0, PALADIN = 0 },
	Ranged = { DRUID = 0, SHAMAN = 0, PRIEST = 0, MAGE = 0, WARLOCK = 0, HUNTER = 0 },
	Melee = { DRUID = 0, SHAMAN = 0, PALADIN = 0, WARRIOR = 0, ROGUE = 0, DEATHKNIGHT = 0 }
}
end

function Aleri.Functions.RefreshRoleTable(level)
	for k, p in ipairs(AleriGlobalSettings.Database) do
		if p.Level >= level then
			if p.MainSpec ~= 'Unknown' then
				if p.MainSpec == 'Beast Master' then
					Aleri.Database.Roles[Aleri.Database.SpecToRole[p.Class]['BeastMaster']][p.Class] = Aleri.Database.Roles[Aleri.Database.SpecToRole[p.Class]['BeastMaster']][p.Class] + 1
				else
					Aleri.Database.Roles[Aleri.Database.SpecToRole[p.Class][p.MainSpec]][p.Class] = Aleri.Database.Roles[Aleri.Database.SpecToRole[p.Class][p.MainSpec]][p.Class] + 1
				end
			end
		end
	end
	for class, count in pairs(Aleri.Database.Roles.Healer) do
		Aleri.Guild.SpecRoleCountFontString.Healer[class]:SetText(count)
	end
	for class, count in pairs(Aleri.Database.Roles.Tank) do
		Aleri.Guild.SpecRoleCountFontString.Tank[class]:SetText(count)
	end
	for class, count in pairs(Aleri.Database.Roles.Melee) do
		Aleri.Guild.SpecRoleCountFontString.Melee[class]:SetText(count)
	end
	for class, count in pairs(Aleri.Database.Roles.Ranged) do
		Aleri.Guild.SpecRoleCountFontString.Range[class]:SetText(count)
	end
end

function Aleri.Functions.ResetClassCountTable()
Aleri.Database.ClassCount = {
	{ Class = 'DEATHKNIGHT', Count = 0 },
	{ Class = 'DRUID', Count = 0 },
	{ Class = 'HUNTER', Count = 0 },
	{ Class = 'MAGE', Count = 0 },
	{ Class = 'PALADIN', Count = 0 },
	{ Class = 'PRIEST', Count = 0 },
	{ Class = 'ROGUE', Count = 0 },
	{ Class = 'SHAMAN', Count = 0 },
	{ Class = 'WARLOCK', Count = 0},
	{ Class = 'WARRIOR', Count  = 0 },
	{ Class = 'Total', Count = 0 }
}
end

function Aleri.Functions.RefreshClassCountTable(level)
	
	local MaxPercent = 0
	for k, p in ipairs(AleriGlobalSettings.Database) do
		if p.Level >= level then
			for k, v in ipairs(Aleri.Database.ClassCount) do
				if v.Class == p.Class then
					v.Count = v.Count + 1
					MaxPercent = MaxPercent + 1
				end
			end
		end
	end

	for k, v in pairs(Aleri.Database.ClassCount) do
		if v.Class == 'Total' then
			v.Count = MaxPercent
		end
	end
	
	table.sort(Aleri.Database.ClassCount, function(a, b) if a.Count ~= nil and b.Count ~= nil then return a.Count > b.Count end end)
	
	for k, v in ipairs(Aleri.Database.ClassCount) do
		Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetText(v.Class)
		Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetTextColor(Aleri.Database.ClassColours[v.Class].r, Aleri.Database.ClassColours[v.Class].g, Aleri.Database.ClassColours[v.Class].b)
		Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetText(v.Count)
		Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetTextColor(Aleri.Database.ClassColours[v.Class].r, Aleri.Database.ClassColours[v.Class].g, Aleri.Database.ClassColours[v.Class].b)
		Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetText(string.format("%.2f", ((v.Count/ MaxPercent) * 100))..'%')
		Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetTextColor(Aleri.Database.ClassColours[v.Class].r, Aleri.Database.ClassColours[v.Class].g, Aleri.Database.ClassColours[v.Class].b)
		Aleri.Guild.PlayerFrameClassStatusBars[k]:SetValue((v.Count/ MaxPercent) * 100)
		Aleri.Guild.PlayerFrameClassStatusBars[k]:SetStatusBarColor(Aleri.Database.ClassColours[v.Class].r, Aleri.Database.ClassColours[v.Class].g, Aleri.Database.ClassColours[v.Class].b)
	end
end

function Aleri.Functions.RefreshRaidStats(sort, level)

	if sort == 'refresh' then
		sort = Aleri.Guild.RaidStatsSort
	end
	
	if Aleri.Guild.PlayerFrame.RaidStatsGridView ~= nil then
		local row = nil
		for i = #Aleri.Guild.PlayerFrame.RaidStatsGridView, 1, -1 do
			row = Aleri.Guild.PlayerFrame.RaidStatsGridView[i]			
			row.ClassIcon:Hide()
			row.Id:SetText(' ')
			row.Name:SetText(' ')
			row.MainSpec:SetText(' ')
			row.MainSpecGearScore:SetText(' ')
			row.OffSpec:SetText(' ')
			row.OffSpecGearScore:SetText(' ')
			row.DKP:SetText(' ')
			row.EditButton:Hide()
			row.PrimaryProf:SetText(' ')
			row.PrimaryProfLevel:SetText(' ')
			row.SecondaryProf:SetText(' ')
			row.SecondaryProfLevel:SetText(' ')
		end
	end
	
	if sort == 'none' then
	
	elseif sort == 'Class' or sort == 'Name' or sort == 'MainSpec' or sort == 'OffSpec' then 
		table.sort(AleriGlobalSettings.Database, function(a,b) if a[sort] ~= nil and b[sort] ~= nil then return a[sort] < b[sort] end end) -- a -> z print( a.Name, a[sort], b.name, b[sort])
	else
		table.sort(AleriGlobalSettings.Database, function(a,b) if a[sort] ~= nil and b[sort] ~= nil then return a[sort] > b[sort] end end)	-- 9 -> 0 print(sort, a.Name, a[sort], b.name, b[sort])
	end
	
	--update listview display
	local row_id = 1
	local row_height = 25
	local vertical_row_offset = 8
	for r, player in ipairs(AleriGlobalSettings.Database) do
			if player.Level >= level then
				--if fontstring exist - update it
				if Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id] ~= nil then
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Id:SetText(row_id)			
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].ClassIcon:Show()				
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].ClassIcon.Texture:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..player.Class)				
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Name:SetText(player.Name)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Name:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpec:SetText(player.MainSpec)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpec:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpecGearScore:SetText(string.format('%.1f', player.MainSpecGearScore))
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpecGearScore:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpec:SetText(player.OffSpec)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpec:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpecGearScore:SetText(string.format('%.1f', player.OffSpecGearScore))
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpecGearScore:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
									
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].DKP:SetText(player.DKP)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].DKP:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
					
					if select(3, GetGuildInfo('player')) > 3 then
						Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].EditButton:Disable()
					end
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].EditButton:Show()
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].EditButton:SetScript('OnClick', function()
						if Aleri.Guild.MemberDetailFrame:IsVisible() and Aleri.Guild.MemberDetailFrame.Title:GetText() == player.Name then
							Aleri.Guild.MemberDetailFrame:Hide()
						else
							Aleri.Guild.CurrentEditingMemberName = player.Name
							Aleri.Guild.MemberDetailFrame:Show()
							Aleri.Guild.MemberDetailFrame.Title:SetText(player.Name)
							Aleri.Guild.MemberDetailFrame.Title:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
							Aleri.Guild.MemberDetailFrame.ClassIcon.Texture:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..player.Class)
							if player.Gender ~= '-' and player.Race ~= '-' then
								Aleri.Guild.MemberDetailFrame.RaceIcon.Texture:SetTexture('Interface\\Addons\\Aleri\\RaceIcons\\'..player.Gender..'\\'..player.Race)
							else
								Aleri.Guild.MemberDetailFrame.RaceIcon.Texture:SetTexture(0,0,0,1)
							end
							Aleri.UpdateEditFrame(player.Name)
							SendChatMessage(UnitName('player')..' is editing '..Aleri.Guild.CurrentEditingMemberName..' !', 'OFFICER')
						end
					end)
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].PrimaryProf:SetText(player.PrimaryProf)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].PrimaryProf:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].PrimaryProfLevel:SetText(player.PrimaryProf)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].PrimaryProfLevel:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)				
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].SecondaryProf:SetText(player.SecondaryProf)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].SecondaryProf:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
					
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].SecondaryProfLevel:SetText(player.SecondaryProf)
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].SecondaryProfLevel:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)				
									
				else
					--create new fonstring if not exist
					local row = { Id = nil, ClassIcon = nil, ClassIconTexture = nil, Name = nil, MainSpec = nil, MainSpecGearScore = nil, Net = nil, Tot = nil, Hrs = nil, OffSpec = nil, OffSpecGearScore = nil, Alt = nil, DKP = nil, EditButton = nil, PrimaryProf = nil, PrimaryProfLevel = nil, SecondaryProf = nil, SecondaryProfLevel = nil } 
					for k, v in ipairs(Aleri.Guild.PlayerFrame.RaidStatsColumns) do
						--if not icon make fontstring
						local fs = nil
						local fs_name = nil
						if v == 'EditButton' then
							local button = CreateFrame('BUTTON', 'AleriGuildPlayerFrameRaidStatsEditButton'..k, Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent, 'UIPanelButtonTemplate')
							button:SetSize(20, 20)
							button:SetPoint('TOPLEFT', 760, ((row_id-1) * - row_height) - (vertical_row_offset - 4))
							button:SetText('*')
							button:SetScript('OnClick', function()
								if Aleri.Guild.MemberDetailFrame:IsVisible() and Aleri.Guild.MemberDetailFrame.Title:GetText() == player.Name then
									Aleri.Guild.MemberDetailFrame:Hide()
								else
									Aleri.Guild.CurrentEditingMemberName = player.Name
									Aleri.Guild.MemberDetailFrame:Show()
									Aleri.Guild.MemberDetailFrame.Title:SetText(player.Name)
									Aleri.Guild.MemberDetailFrame.Title:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
									Aleri.Guild.MemberDetailFrame.ClassIcon.Texture:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..player.Class)
									if player.Gender ~= '-' and player.Race ~= '-' then
										Aleri.Guild.MemberDetailFrame.RaceIcon.Texture:SetTexture('Interface\\Addons\\Aleri\\RaceIcons\\'..player.Gender..'\\'..player.Race)
									else
										Aleri.Guild.MemberDetailFrame.RaceIcon.Texture:SetTexture(0,0,0,1)
									end
									Aleri.UpdateEditFrame(player.Name)
									SendChatMessage(UnitName('player')..' is editing '..Aleri.Guild.CurrentEditingMemberName..' !', 'OFFICER')
								end
							end)
							if select(3, GetGuildInfo('player')) > 3 then
								button:Disable()
							end
							row[v] = button
						end
						if v ~= 'ClassIcon' and v ~= 'EditButton' then
							fs_name = '_'..v..k
							fs = Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:CreateFontString('AleriGuildPlayerFrameRaidStatsGridView'..fs_name, 'OVERLAY', 'GameFontNormal')
							fs:SetText(player[v])
							fs:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
							row[v] = fs
						end
						-- set class icon
						if v == 'ClassIcon' then						
							local iconFrame = CreateFrame('FRAME', 'AleriGuildPlayerFrameRaidStatsIcon'..k, Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent)
							iconFrame:SetPoint('TOPLEFT', 115, ((row_id-1) * - row_height) - (vertical_row_offset - 4))
							iconFrame:SetSize(24, 24)
							iconFrame.Texture = iconFrame:CreateTexture('$parent_Texture', 'BACKGROUND')
							iconFrame.Texture:SetAllPoints(iconFrame)
							iconFrame.Texture:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..player.Class)
							row['ClassIcon'] = iconFrame
						--set listview row id
						elseif v == 'Id' then
							fs:SetText(row_id)
							fs:SetTextColor(1,1,1)
							fs:SetPoint('TOPLEFT', 0, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(28)
							fs:SetJustifyH('RIGHT')
							row[v] = fs
						--set all other columns
						elseif v == 'Name' then
							fs:SetPoint('TOPLEFT', 30, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(120)
							fs:SetJustifyH('LEFT')
						elseif v == 'MainSpec' then
							fs:SetPoint('TOPLEFT', 150, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(90)
							--fs:SetHeight(24)
							fs:SetJustifyH('LEFT')
						elseif v == 'MainSpecGearScore' then
							fs:SetPoint('TOPLEFT', 240, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(40)
							fs:SetJustifyH('CENTER')
							fs:SetText(string.format('%.1f', player[v]))
						elseif v == 'OffSpec' then
							fs:SetPoint('TOPLEFT', 280, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(90)
							fs:SetJustifyH('LEFT')
						elseif v == 'OffSpecGearScore' then
							fs:SetPoint('TOPLEFT', 370, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(40)
							fs:SetJustifyH('CENTER')
							fs:SetText(string.format('%.1f', player[v]))
						elseif v == 'DKP' then
							fs:SetPoint('TOPLEFT', 410, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(40)
							fs:SetJustifyH('CENTER')
						elseif v == 'PrimaryProf' then
							fs:SetPoint('TOPLEFT', 460, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(100)
							fs:SetJustifyH('LEFT')
						elseif v == 'PrimaryProfLevel' then
							fs:SetPoint('TOPLEFT', 560, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(50)
							fs:SetJustifyH('CENTER')	
						elseif v == 'SecondaryProf' then
							fs:SetPoint('TOPLEFT', 610, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(100)
							fs:SetJustifyH('LEFT')
						elseif v == 'SecondaryProfLevel' then
							fs:SetPoint('TOPLEFT', 710, ((row_id-1) * - row_height) - vertical_row_offset)
							fs:SetWidth(50)
							fs:SetJustifyH('CENTER')						
						elseif v == 'Alt' then
						
						end					
					end
					table.insert(Aleri.Guild.PlayerFrame.RaidStatsGridView, row)
				end
				row_id = row_id + 1
			end
			

	end
	Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:SetHeight((row_id - 1) * (row_height))
end

function Aleri.Functions.GetArgs(...)
	for i=1, select("#", ...) do
		arg = select(i, ...)
		print(i.." "..tostring(arg))
	end
end

function Aleri.Functions.MakeFrameMove(frame)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
end

